import csv
import openai
import time

# Replace 'YOUR_OPENAI_API_KEY' with your actual OpenAI API key
openai.api_key = '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'

# Determine the maximum token limit based on your API plan
MAX_TOKENS_LIMIT = 4000  # Adjust this value based on your plan
PROMPT_MAX_LENGTH = 4000   # Set a shorter prompt length (adjust as needed)

def read_categories_from_csv(file_path, set_index, separator=","):
    categories = []

    with open(file_path, newline='', encoding='utf-8') as csvfile:
        reader = csv.reader(csvfile)
        next(reader)  # Skip the header row
        for row in reader:
            category = row[set_index].strip()  # Remove leading and trailing whitespaces
            # Split categories using the specified separator
            categories.extend(category.split(separator))

    return categories

def find_best_matching_category(categories_set1, categories_set2, output_file):
    results = {}
    
    # Initialize counters
    rpd_counter = 0  # Requests per day counter
    rpm_counter = 0  # Requests per minute counter
    tpm_counter = 0  # Tokens per minute counter

    for category_set1 in categories_set1:
        best_match = None
        best_confidence = 0.0

        for category_set2 in categories_set2:
            # Construct the prompt for comparison using OpenAI's text completions
            prompt = f"Match the following categories: {category_set1}; {category_set2}."

            try:
                # Rate limiting checks
                if rpd_counter >= 2000:
                    print("Daily rate limit reached. Waiting for a new day to continue.")
                    time.sleep(86400)  # Wait for 24 hours (in seconds) to reset the daily limit
                    rpd_counter = 0

                if rpm_counter >= 60:
                    print("Rate limit per minute reached. Waiting for a minute to continue.")
                    time.sleep(60)  # Wait for a minute (in seconds) to reset the minute limit
                    rpm_counter = 0

                if tpm_counter >= 250000:
                    print("Token limit per minute reached. Waiting for a minute to continue.")
                    time.sleep(60)  # Wait for a minute (in seconds) to reset the token limit
                    tpm_counter = 0

                # Call the OpenAI API to get the completion using GPT-3.5 Turbo engine
                response = openai.Completion.create(
                    engine="text-davinci-003",  # Use GPT-3.5 Turbo engine
                    prompt=prompt,
                    max_tokens=MAX_TOKENS_LIMIT,
                    stop=None,
                    temperature=0.7,  # Set a low temperature for focused responses
                )

                # Get the generated text of the completion
                completion_text = response['choices'][0]['text']

                # Extract the best match and confidence from the completion response
                completion_confidence = response['choices'][0].get('confidence', 0.0)
                if completion_confidence > best_confidence:
                    best_match = category_set2
                    best_confidence = completion_confidence

                # Increment counters after a successful API call
                rpd_counter += 1
                rpm_counter += 1
                tpm_counter += len(response['choices'][0]['text'].split())  # Count tokens in the response

            except Exception as e:
                print(f"Error occurred for '{category_set1}': {str(e)}")

        # Store the best match for the category from "set1.csv"
        results[category_set1] = best_match

        # Write the matched category to the CSV file
        with open(output_file, mode='a', newline='', encoding='utf-8') as csvfile:
            writer = csv.writer(csvfile)
            writer.writerow([category_set1, best_match])
            csvfile.flush()  # Flush the buffer to save the data immediately

    return results

if __name__ == "__main__":
    # Example usage
    set1_file_path = 'set1.csv'
    set2_file_path = 'set2.csv'
    output_file_path = "new_matched_results.csv"

    # Write the header to the CSV file
    with open(output_file_path, mode='w', newline='', encoding='utf-8') as csvfile:
        writer = csv.writer(csvfile)
        writer.writerow(['Category_Set1', 'Matched_Category_Set2'])

    categories_set1 = read_categories_from_csv(set1_file_path, set_index=0, separator=",")
    categories_set2 = read_categories_from_csv(set2_file_path, set_index=0, separator=",")

    matched_categories = find_best_matching_category(categories_set1, categories_set2, output_file_path)

    # Output the matched categories to the console
    for category_set1, matched_category in matched_categories.items():
        print(f"Matched '{category_set1}' to: {matched_category}")
